libdap::Sequence Class Reference

Holds a sequence. More...

`#include <Sequence.h>`

Inheritance diagram for libdap::Sequence:

## Public Types

typedef stack< BaseType * > | btp_stack
typedef std::vector< BaseType * >::const_iterator | Vars_citer
typedef std::vector< BaseType * >::iterator | Vars_iter
typedef std::vector< BaseType * >::reverse_iterator | Vars_riter

## Public Member Functions

void | add_var (BaseType *bt, Part part=nil) override
void | add_var_nocopy (BaseType *bt, Part part=nil) override
unsigned int | buf2val (void **) override
| Reads the class data.
bool | check_semantics (string &msg, bool all=false) override
| Compare an object's current state with the semantics of its type.
virtual void | clear_local_data ()
void | compute_checksum (Crc32 &checksum) override
| include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum.
virtual bool | d4_ops (BaseType *b, int op)
| Evaluator a relop for DAP4.
virtual string | dataset () const
| Returns the name of the dataset used to create this instance.
virtual void | del_var (const string &name)
| Remove an element from a Constructor.
virtual void | del_var (Vars_iter i)
| Delete the BaseType* and erase the iterator .
void | deserialize (D4StreamUnMarshaller &um, DMR &dmr) override
virtual bool | deserialize (UnMarshaller &um, DDS *dds, bool reuse=false)
| Deserialize (read from the network) the entire Sequence.
virtual void | dump (ostream &strm) const
| dumps information about this object
int | element_count (bool leaves=false) override
| Count the members of constructor types.
std::string | FQN () const override
virtual BaseType * | get_ancestor ()
virtual AttrTable & | get_attr_table ()
virtual int | get_ending_row_number ()
| Get the ending row number.
virtual BaseType * | get_parent () const
int | get_row_number () const
virtual int | get_row_stride ()
| Get the row stride.
int | get_starting_row_number ()
| Get the starting row number.
bool | get_unsent_data () const
| Get the unsent data property.
BaseType * | get_var_index (int i)
Vars_iter | get_vars_iter (int i)
void | increment_row_number (unsigned int i)
void | intern_data () override
| Read data into this variable.
virtual void | intern_data (ConstraintEvaluator &eval, DDS &dds)
virtual bool | is_constructor_type () const
| Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable.
virtual bool | is_dap2_only_type ()
virtual bool | is_dap4 () const
bool | is_dap4_projected (std::vector< std::string > &inventory) override
virtual bool | is_in_selection ()
| Is this variable part of the current selection?
virtual bool | is_leaf_sequence ()
virtual bool | is_linear ()
| Check to see whether this variable can be printed simply.
virtual bool | is_simple_type () const
| Returns true if the instance is a numeric, string or URL type variable.
virtual bool | is_vector_type () const
| Returns true if the instance is a vector (i.e., array) type variable.
virtual int | length () const
virtual int64_t | length_ll () const
| Get the number of elements in this variable This version of the function deprecates length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that a Vector/Array holds no values yet (as opposed to zero values). For types not derived from Vector, there is always one element.
virtual string | name () const
| Returns the name of the class instance.
virtual int | number_of_rows () const
Sequence & | operator= (const Sequence &rhs)
virtual bool | ops (BaseType *b, int op)
| Evaluate relational operators.
void | print_dap4 (XMLWriter &xml, bool constrained=false) override
void | print_decl (FILE *out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false) override
| Print an ASCII representation of the variable structure.
void | print_decl (ostream &out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false) override
| Print an ASCII representation of the variable structure.
virtual void | print_one_row (FILE *out, int row, string space, bool print_row_num=false)
virtual void | print_one_row (ostream &out, int row, string space, bool print_row_num=false)
virtual void | print_val (FILE *out, string space="", bool print_decl_p=true)
| Prints the value of the variable.
virtual void | print_val (ostream &out, string space="", bool print_decl_p=true)
| Prints the value of the variable.
virtual void | print_val_by_rows (FILE *out, string space="", bool print_decl_p=true, bool print_row_numbers=true)
virtual void | print_val_by_rows (ostream &out, string space="", bool print_decl_p=true, bool print_row_numbers=true)
void | print_xml (FILE *out, string space=" ", bool constrained=false) override
void | print_xml (ostream &out, string space=" ", bool constrained=false) override
void | print_xml_writer (XMLWriter &xml, bool constrained=false) override
virtual BaseType * | ptr_duplicate ()
bool | read () override
| Read the elements of Constructor marked for transmission.
virtual bool | read_p ()
| Has this variable been read?
virtual bool | read_row (int row, DDS &dds, ConstraintEvaluator &eval, bool ce_eval=true)
void | reset_row_number ()
| Rest the row number counter.
void | reset_row_number (bool recur)
| A recursive version of reset_row_number()
virtual BaseTypeRow * | row_value (size_t row)
| Get a whole row from the sequence.
virtual bool | send_p ()
| Should this variable be sent?
| Sequence (const Sequence &rhs)
| The Sequence copy constructor.
| Sequence (const string &n)
| The Sequence constructor.
| Sequence (const string &n, const string &d)
| The Sequence server-side constructor.
virtual bool | serialize (ConstraintEvaluator &eval, DDS &dds, Marshaller &m, bool ce_eval=true)
void | serialize (D4StreamMarshaller &m, DMR &dmr, bool filter=false) override
| Serialize a Constructor.
virtual void | set_attr_table (const AttrTable &at)
void | set_in_selection (bool state) override
| Set the in_selection property.
virtual void | set_is_dap4 (const bool v)
virtual void | set_leaf_p (bool state)
virtual void | set_leaf_sequence (int lvl=1)
| Mark the Sequence which holds the leaf elements.
virtual void | set_length (int64_t)
| Set the number of elements for this variable. use -1 to indicate nothing set.
virtual void | set_length_ll (int64_t)
| Set the number of elements in this variable This version of the function deprecates set_length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values.
virtual void | set_name (const string &n)
| Sets the name of the class instance.
virtual void | set_parent (BaseType *parent)
void | set_read_p (bool state) override
| Set the 'read_p' property for the Constructor and its members.
virtual void | set_row_number_constraint (int start, int stop, int stride=1)
void | set_send_p (bool state) override
virtual void | set_synthesized_p (bool state)
virtual void | set_type (const Type &t)
| Sets the type of the class instance.
void | set_unsent_data (bool usd)
| Set the unsent data property.
virtual void | set_value (SequenceValues &values)
void | set_var_index (BaseType *bt, int i)
| Set the ith element of d_vars to a variable object.
virtual bool | synthesized_p ()
virtual string | toString ()
void | transfer_attributes (AttrTable *at) override
virtual std::vector< BaseType * > * | transform_to_dap2 (AttrTable *parent_attr_table)
| DAP4 to DAP2 transform.
virtual void | transform_to_dap4 (D4Group *root, Constructor *container)
virtual Type | type () const
| Returns the type of the class instance.
virtual string | type_name () const
| Returns the type of the class instance as a string.
unsigned int | val2buf (void *, bool) override
| Loads class data.
virtual SequenceValues | value ()
virtual SequenceValues & | value_ref ()
BaseType * | var (const string &n, btp_stack &s) override
BaseType * | var (const string &name, bool exact_match=true, btp_stack *s=nullptr) override
| btp_stack no longer needed; use back pointers (BaseType::get_parent())
Vars_iter | var_begin ()
Vars_iter | var_end ()
Vars_riter | var_rbegin ()
Vars_riter | var_rend ()
virtual BaseType * | var_value (size_t row, const string &name)
| Get the BaseType pointer to the named variable of a given row.
virtual BaseType * | var_value (size_t row, size_t i)
| Get the BaseType pointer to the $i^{th}$ variable of row.
const vector< BaseType * > & | variables () const
unsigned int | width (bool constrained=false) const override
int64_t | width_ll (bool constrained=false) const override
| Get the width of the Constructor's fields.
virtual D4Attributes * | attributes ()
virtual void | set_attributes (D4Attributes *)
virtual void | set_attributes_nocopy (D4Attributes *)

## Static Public Member Functions

static AttrTable * | make_dropped_vars_attr_table (vector< BaseType * > *dropped_vars)

## Protected Types

typedef stack< SequenceValues * > | sequence_values_stack_t

## Protected Member Functions

virtual void | intern_data_for_leaf (DDS &dds, ConstraintEvaluator &eval, sequence_values_stack_t &sequence_values_stack)
virtual void | intern_data_parent_part_one (DDS &dds, ConstraintEvaluator &eval, sequence_values_stack_t &sequence_values_stack)
virtual void | intern_data_parent_part_two (DDS &dds, ConstraintEvaluator &eval, sequence_values_stack_t &sequence_values_stack)
virtual void | intern_data_private (ConstraintEvaluator &eval, DDS &dds, sequence_values_stack_t &sequence_values_stack)
void | m_duplicate (const BaseType &bt)
| Perform a deep copy.
void | m_duplicate (const Sequence &s)
BaseType * | m_exact_match (const string &name, btp_stack *s=nullptr)
BaseType * | m_leaf_match (const string &name, btp_stack *s=nullptr)
virtual bool | serialize_leaf (DDS &dds, ConstraintEvaluator &eval, Marshaller &m, bool ce_eval)
virtual bool | serialize_parent_part_one (DDS &dds, ConstraintEvaluator &eval, Marshaller &m)
virtual void | serialize_parent_part_two (DDS &dds, ConstraintEvaluator &eval, Marshaller &m)

## Protected Attributes

std::vector< BaseType * > | d_vars

## Friends

class | SequenceTest

## Detailed Description

Holds a sequence.

This is the interface for the class Sequence. A sequence contains a single set of variables, all at the same lexical level just like a Structure. Like a Structure, a Sequence may contain other compound types, including other Sequences. Unlike a Structure, a Sequence defines a pattern that is repeated N times for a sequence of N elements. It is useful to think of a Sequence as representing a table of values (like a relational database), with each row of the table corresponding to a Sequence `instance.'' (This usage can be confusing, since`instance'' also refers to a particular item of class Sequence.) For example:

    Sequence {
    String name;
    Int32 age;
    } person;

This represents a Sequence of `‘person’' records, each instance of which contains a name and an age:

    Fred       34
    Ralph      23
    Andrea     29
    ...

A Sequence can be arbitrarily long, which is to say that its length is not part of its declaration. A Sequence can contain other Sequences:

    Sequence {
    String name;
    Int32 age;
    Sequence {
    String friend;
    } friend_list;
    } person;

This is still represented as a single table, but each row contains the elements of both the main Sequence and the nested one:

    Fred       34     Norman
    Fred       34     Andrea
    Fred       34     Ralph
    Fred       34     Lisa
    Ralph      23     Norman
    Ralph      23     Andrea
    Ralph      23     Lisa
    Ralph      23     Marth
    Ralph      23     Throckmorton
    Ralph      23     Helga
    Ralph      23     Millicent
    Andrea     29     Ralph
    Andrea     29     Natasha
    Andrea     29     Norman
    ...        ..     ...

Internally, the Sequence is represented by a vector of vectors. The members of the outer vector are the members of the Sequence. This includes the nested Sequences, as in the above example.

NB: Note that in the past this class had a different behavior. It held only one row at a time and the deserialize(...) method had to be called from within a loop. This is no longer true. Now the deserailize(...) method should be called once and will read the entire sequence's values from the server. All the values are now stored in an instance of Sequence, not just a single row's.

Because the length of a Sequence is indeterminate, there are changes to the behavior of the functions to read this class of data. The `read()` function for Sequence must be written so that successive calls return values for successive rows of the Sequence.

Similar to a C structure, you refer to members of Sequence elements with a `.'' notation. For example, if the Sequence has a member Sequence called`Tom'' and Tom has a member Float32 called `shoe_size'', you can refer to Tom's shoe size as` Tom.shoe_size''.

Note
  This class contains the 'logic' for both the server- and client-side behavior. The field d_values is used by the client-side methods to store the entire Sequence. On the server-side, the read() method uses an underlying data system to read one row of data values which are then serialized using the serialize() methods of each variable.

Todo:
  Add an isEmpty() method which returns true if the Sequence is empty. This should work before and after calling deserialize().

Definition at line 162 of file Sequence.h.

## Member Typedef Documentation

## btp_stack

typedef stack<BaseType *> libdap::BaseType::btp_stack

inherited

Definition at line 149 of file BaseType.h.

## sequence_values_stack_t

typedef stack<SequenceValues *> libdap::Sequence::sequence_values_stack_t

protected

Definition at line 203 of file Sequence.h.

## Vars_citer

typedef std::vector<BaseType*>::const_iterator libdap::Constructor::Vars_citer

inherited

Definition at line 59 of file Constructor.h.

## Vars_iter

typedef std::vector<BaseType*>::iterator libdap::Constructor::Vars_iter

inherited

Definition at line 60 of file Constructor.h.

## Vars_riter

typedef std::vector<BaseType*>::reverse_iterator libdap::Constructor::Vars_riter

inherited

Definition at line 61 of file Constructor.h.

## Constructor & Destructor Documentation

## Sequence() [1/3]

libdap::Sequence::Sequence | ( | const string & | n | ) |

The Sequence constructor.

The Sequence constructor requires only the name of the variable to be created. The name may be omitted, which will create a nameless variable. This may be adequate for some applications.

Parameters

  n | A string containing the name of the variable to be created.

Definition at line 146 of file Sequence.cc.

## Sequence() [2/3]

libdap::Sequence::Sequence | ( | const string & | n,
|  | const string & | d
| ) |  |

The Sequence server-side constructor.

The Sequence server-side constructor requires the name of the variable to be created and the dataset name from which this variable is being created.

Parameters

  n | A string containing the name of the variable to be created.
  d | A string containing the name of the dataset from which this variable is being created.

Definition at line 160 of file Sequence.cc.

## Sequence() [3/3]

libdap::Sequence::Sequence | ( | const Sequence & | rhs | ) |

The Sequence copy constructor.

Definition at line 165 of file Sequence.cc.

## ~Sequence()

libdap::Sequence::~Sequence | ( |  | ) |

virtual

Definition at line 210 of file Sequence.cc.

## Member Function Documentation

## add_var()

void libdap::Constructor::add_var | ( | BaseType * | bt,
|  | Part | part = `nil`
| ) |  |

override virtual inherited

Adds an element to a Constructor.

Parameters

  bt | A pointer to the variable to add to this Constructor.
  part | Not used by this class, defaults to nil

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 322 of file Constructor.cc.

## add_var_nocopy()

void libdap::Constructor::add_var_nocopy | ( | BaseType * | bt,
|  | Part | part = `nil`
| ) |  |

override virtual inherited

Adds an element to a Constructor.

Parameters

  bt | A pointer to thee variable to add to this Constructor.
  part | Not used by this class, defaults to nil

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 340 of file Constructor.cc.

## attributes()

D4Attributes * libdap::BaseType::attributes | ( |  | ) |

virtual inherited

DAP4 Attribute methods

Definition at line 507 of file BaseType.cc.

## buf2val()

unsigned int libdap::Constructor::buf2val | ( | void ** | val | ) |

inline override virtual inherited

Reads the class data.

Reads the class data into the memory referenced by val. The caller should either allocate enough storage to val to hold the class data or set `*val` to null. If *val is NULL, memory will be allocated by this function with `new()`. If the memory is allocated this way, the caller is responsible for deallocating that memory. Array and values for simple types are stored as C would store an array.

Deprecated:
  Use value() in the leaf classes.

Parameters

  val | A pointer to a pointer to the memory into which the class data will be copied. If the value pointed to is NULL, memory will be allocated to hold the data, and the pointer value modified accordingly. The calling program is responsible for deallocating the memory references by this pointer.

Returns
  The size (in bytes) of the information copied to val.

Implements libdap::BaseType.

Definition at line 137 of file Constructor.h.

## check_semantics()

bool libdap::Constructor::check_semantics | ( | string & | msg,
|  | bool | all = `false`
| ) |  |

override virtual inherited

Compare an object's current state with the semantics of its type.

This function checks the class instance for internal consistency. This is important to check for complex constructor classes. For BaseType, an object is semantically correct if it has both a non-null name and type.

For example, an Int32 instance would return FALSE if it had no name or no type defined. A Grid instance might return FALSE for more complex reasons, such as having Map arrays of the wrong size or shape.

This function is used by the DDS class, and will rarely, if ever, be explicitly called by a DODS application program. A variable must pass this test before it is sent, but there may be many other stages in a retrieve operation where it would fail.

Returns
  Returns FALSE when the current state violates some aspect of the type semantics, TRUE otherwise.

Parameters

  msg | A returned string, containing a message indicating the source of any problem.
  all | For complex constructor types (Grid, Sequence, Structure), this flag indicates whether to check the semantics of the member variables, too.

See also
  DDS::check_semantics

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 622 of file Constructor.cc.

## clear_local_data()

void libdap::Sequence::clear_local_data | ( |  | ) |

virtual

Remove any read or set data in the private data of the variable, setting read_p() to false. Used to clear any dynamically allocated storage that holds (potentially large) data. For the simple types, this no-op version is all that's needed. Vector and some other classes define a special version and have serialize() implementations that call it to free data as soon as possible after sending it.

Note
  Added 7/5/15 jhrg
  Any specialization of this should make sure to reset the read_p property.

Reimplemented from libdap::BaseType.

Definition at line 218 of file Sequence.cc.

## compute_checksum()

void libdap::Constructor::compute_checksum | ( | Crc32 & | checksum | ) |

override virtual inherited

include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum.

Parameters

  checksum | A Crc32 instance that holds the current checksum.

Implements libdap::BaseType.

Definition at line 453 of file Constructor.cc.

## d4_ops()

bool libdap::BaseType::d4_ops | ( | BaseType * | b,
|  | int | op
| ) |  |

virtual inherited

Evaluator a relop for DAP4.

This method is used by the filter expression evaluation code in DAP4. Each of the 'data type' classes that support relops must overload this method. In an expression of the form arg1 op arg2, this object is arg1, the parameter 'b' is arg2 and op is the relational operator.

Note
  I used the same relop codes for DAP4 as in the DAP2 parser/scanner which makes for some coupling between them, but cuts way down on the duplication of the evaluator logic, which is somewhat involved.

Parameters

  b | The second argument in the relational expression
  op | The infix relational operator

Returns
  True if the expression is true, False otherwise.

Reimplemented in libdap::Byte, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Int64, libdap::Int8, libdap::Str, and libdap::UInt64.

Definition at line 1125 of file BaseType.cc.

## dataset()

string libdap::BaseType::dataset | ( |  | ) | const

virtual inherited

Returns the name of the dataset used to create this instance.

A dataset from which the data is to be read. The meaning of this string will vary among different types of data sources. It may be the name of a data file or an identifier used to read data from a relational database.

Definition at line 326 of file BaseType.cc.

## del_var() [1/2]

void libdap::Constructor::del_var | ( | const string & | n | ) |

virtual inherited

Remove an element from a Constructor.

Note
  New version. There is a subtle change in that this version will remove all variables in this Constructor with name 'n' while the old version would just remove the first variable.

Parameters

  n | name of the variable to remove

Definition at line 359 of file Constructor.cc.

## del_var() [2/2]

void libdap::Constructor::del_var | ( | Vars_iter | i | ) |

virtual inherited

Delete the BaseType* and erase the iterator .

Note
  It is OK to call this with an iterator that points to nullptr.

Parameters

  i | The iterator that points to the BaseType.

Definition at line 370 of file Constructor.cc.

## deserialize() [1/2]

void libdap::Constructor::deserialize | ( | D4StreamUnMarshaller & | um,
|  | DMR & | dmr
| ) |  |

override virtual inherited

The DAP4 deserialization method.

Parameters

  um |
  dmr |

Exceptions

  Error | or InternalErr

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group, and libdap::D4Sequence.

Definition at line 500 of file Constructor.cc.

## deserialize() [2/2]

bool libdap::Sequence::deserialize | ( | UnMarshaller & | um,
|  | DDS * | dds,
|  | bool | reuse = `false`
| ) |  |

virtual

Deserialize (read from the network) the entire Sequence.

This method used to read a single row at a time. Now the entire sequence is read at once. The method used to return True to indicate that more data needed to be deserialized and False when the sequence was completely read. Now it simply returns false. This might seem odd, but making this method return false breaks existing software the least.

Parameters

  um | An UnMarshaller that knows how to deserialize data
  dds | A DataDDS from which to read.
  reuse | Passed to child objects when they are deserialized. Some implementations of deserialize() use this to determine if new storage should be allocated or existing storage reused.

Exceptions

  Error | if a sequence stream marker cannot be read.
  InternalErr | if the `dds` param is not a DataDDS.

Returns
  A return value of false indicates that an EOS ("end of Sequence") marker was found, while a value of true indicates that there are more rows to be read. This version always reads the entire sequence, so it always returns false.

Reimplemented from libdap::Constructor.

Definition at line 937 of file Sequence.cc.

## dump()

void libdap::Sequence::dump | ( | ostream & | strm | ) | const

virtual

dumps information about this object

Displays the pointer value of this instance and information about this instance.

Parameters

  strm | C++ i/o stream to dump the information to

Returns
  void

Reimplemented from libdap::Constructor.

Definition at line 1190 of file Sequence.cc.

## element_count()

int libdap::Constructor::element_count | ( | bool | leaves = `false` | ) |

override virtual inherited

Count the members of constructor types.

Return a count of the total number of variables in this variable. This is used to count the number of variables held by a constructor variable - for simple type and vector variables it always returns 1.

For compound data types, there are two ways to count members. You can count the members, or you can count the simple members and add that to the count of the compound members. For example, if a Structure contains an Int32 and another Structure that itself contains two Int32 members, the element count of the top-level structure could be two (one Int32 and one Structure) or three (one Int32 by itself and two Int32's in the subsidiary Structure). Use the leaves parameter to control which kind of counting you desire.

Returns
  Returns 1 for simple types. For compound members, the count depends on the leaves argument.

Parameters

  leaves | This parameter is only relevant if the object contains other compound data types. If FALSE, the function counts only the data variables mentioned in the object's declaration. If TRUE, it counts the simple members, and adds that to the sum of the counts for the compound members. This parameter has no effect for simple type variables.

Reimplemented from libdap::BaseType.

Definition at line 109 of file Constructor.cc.

## FQN()

string libdap::Constructor::FQN | ( |  | ) | const

override virtual inherited

Return the FQN for this variable. This will include the D4 Group component of the name.

Returns
  The FQN in a string

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 98 of file Constructor.cc.

## get_ancestor()

BaseType * libdap::BaseType::get_ancestor | ( |  | ) |

virtual inherited

Definition at line 638 of file BaseType.cc.

## get_attr_table()

AttrTable & libdap::BaseType::get_attr_table | ( |  | ) |

virtual inherited

Get this variable's AttrTable. It's generally a bad idea to return a reference to a contained object, but in this case it seems that building an interface inside BaseType is overkill.

Use the AttrTable methods to manipulate the table.

Definition at line 498 of file BaseType.cc.

## get_ending_row_number()

int libdap::Sequence::get_ending_row_number | ( |  | ) |

virtual

Get the ending row number.

Return the ending row number if the sequence was constrained using row numbers (instead of, or in addition to, a relational constraint). If a relational constraint was also given, the row number corresponds to the row number of the sequence after applying the relational constraint.

If the bracket notation was not used to constrain this sequence, this method returns -1.

Returns
  The ending row number.

Definition at line 1018 of file Sequence.cc.

## get_parent()

BaseType * libdap::BaseType::get_parent | ( |  | ) | const

virtual inherited

Return a pointer to the Constructor or Vector which holds (contains) this variable. If this variable is at the top level, this method returns null.

Returns
  A BaseType pointer to the variable's parent.

Definition at line 636 of file BaseType.cc.

## get_row_number()

int libdap::Sequence::get_row_number | ( |  | ) | const

inline

Definition at line 258 of file Sequence.h.

## get_row_stride()

int libdap::Sequence::get_row_stride | ( |  | ) |

virtual

Get the row stride.

Return the row stride number if the sequence was constrained using row numbers (instead of, or in addition to, a relational constraint). If a relational constraint was also given, the row stride is applied to the sequence after applying the relational constraint.

If the bracket notation was not used to constrain this sequence, this method returns -1.

Returns
  The row stride.

Definition at line 1005 of file Sequence.cc.

## get_starting_row_number()

int libdap::Sequence::get_starting_row_number | ( |  | ) |

Get the starting row number.

Return the starting row number if the sequence was constrained using row numbers (instead of, or in addition to, a relational constraint). If a relational constraint was also given, the row number corresponds to the row number of the sequence after applying the relational constraint.

If the bracket notation was not used to constrain this sequence, this method returns -1.

Returns
  The starting row number.

Definition at line 993 of file Sequence.cc.

## get_unsent_data()

bool libdap::Sequence::get_unsent_data | ( |  | ) | const

inline

Get the unsent data property.

Definition at line 269 of file Sequence.h.

## get_var_index()

BaseType * libdap::Constructor::get_var_index | ( | int | i | ) |

inherited

Return the BaseType pointer for the ith variable.

Parameters

  i | This index

Returns
  The corresponding BaseType*.

Definition at line 290 of file Constructor.cc.

## get_vars_iter()

Constructor::Vars_iter libdap::Constructor::get_vars_iter | ( | int | i | ) |

inherited

Return the iterator for the ith variable.

Parameters

  i | the index

Returns
  The corresponding Vars_iter

Definition at line 285 of file Constructor.cc.

## increment_row_number()

void libdap::Sequence::increment_row_number | ( | unsigned int | i | ) |

inline

Definition at line 257 of file Sequence.h.

## intern_data() [1/2]

void libdap::Constructor::intern_data | ( |  | ) |

override virtual inherited

Read data into this variable.

Parameters

  eval | Evaluator for a constraint expression
  dmr | DMR for the whole dataset

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group, and libdap::D4Sequence.

Definition at line 457 of file Constructor.cc.

## intern_data() [2/2]

void libdap::Sequence::intern_data | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds
| ) |  |

virtual

This method is used to evaluate a constraint and based on those results load the Sequence variable with data. This simulates having a server call the serialize() method and a client call the deserialize() method without the overhead of any IPC. Use this method on the server-side to 'load the d_values field with data' so that other code and work with those data.

The somewhat odd algorithm used by serialize() is largely copied here, so comments about logic in serialize() and the related methods apply here as well.

Note
  Even though each Sequence variable has a values field, only the top-most Sequence in a hierarchy of Sequences holds values. The field accessed by the var_value() method is a completely linked object; access the values of nested Sequences using the BaseType objects returned by var_value().
  Only call this method for top-most Sequences. Never call it for Sequences which have a parent (directly or indirectly) variable that is a Sequence.

Parameters

  eval | Use this constraint evaluator
  dds | This DDS holds the variables for the data source

Reimplemented from libdap::Constructor.

Definition at line 732 of file Sequence.cc.

## intern_data_for_leaf()

void libdap::Sequence::intern_data_for_leaf | ( | DDS & | dds,
|  | ConstraintEvaluator & | eval,
|  | sequence_values_stack_t & | sequence_values_stack
| ) |  |

protected virtual

Definition at line 863 of file Sequence.cc.

## intern_data_parent_part_one()

void libdap::Sequence::intern_data_parent_part_one | ( | DDS & | dds,
|  | ConstraintEvaluator & | eval,
|  | sequence_values_stack_t & | sequence_values_stack
| ) |  |

protected virtual

Definition at line 761 of file Sequence.cc.

## intern_data_parent_part_two()

void libdap::Sequence::intern_data_parent_part_two | ( | DDS & | dds,
|  | ConstraintEvaluator & | eval,
|  | sequence_values_stack_t & | sequence_values_stack
| ) |  |

protected virtual

Definition at line 818 of file Sequence.cc.

## intern_data_private()

void libdap::Sequence::intern_data_private | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds,
|  | sequence_values_stack_t & | sequence_values_stack
| ) |  |

protected virtual

Definition at line 751 of file Sequence.cc.

## is_constructor_type()

bool libdap::BaseType::is_constructor_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable.

Returns
  True if the instance is a Structure, Sequence or Grid, False otherwise.

Definition at line 358 of file BaseType.cc.

## is_dap2_only_type()

bool libdap::Sequence::is_dap2_only_type | ( |  | ) |

virtual

The Sequence class will be streamlined for DAP4.

Definition at line 238 of file Sequence.cc.

## is_dap4()

virtual bool libdap::BaseType::is_dap4 | ( |  | ) | const

inline virtual inherited

Definition at line 181 of file BaseType.h.

## is_dap4_projected()

bool libdap::Constructor::is_dap4_projected | ( | std::vector< std::string > & | inventory | ) |

override virtual inherited

When send_p() is true and the attributes or variables contain dap4 data types then a description of the instance is added to the inventory and true is returned.

Parameters

  inventory | is a value-result parameter

Returns
  True when send_p() is true and this object contains dap4 types variables or attributes, false otherwise

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 722 of file Constructor.cc.

## is_in_selection()

bool libdap::BaseType::is_in_selection | ( |  | ) |

virtual inherited

Is this variable part of the current selection?

Does this variable appear in either the selection part or as a function argument in the current constrain expression. If this property is set (true) then implementations of the read() method should read this variable.

Note
  This method does not check, nor does it know about the semantics of, string arguments passed to functions. Those functions might include variable names in strings; they are responsible for reading those variables. See the grid (func_grid_select()) for an example.

See also
  BaseType::read()

Definition at line 600 of file BaseType.cc.

## is_leaf_sequence()

bool libdap::Sequence::is_leaf_sequence | ( |  | ) |

virtual

Definition at line 1122 of file Sequence.cc.

## is_linear()

bool libdap::Sequence::is_linear | ( |  | ) |

virtual

Check to see whether this variable can be printed simply.

True if the instance can be flattened and printed as a single table of values. For Arrays and Grids this is always false. For Structures and Sequences the conditions are more complex. The implementation provided by this class always returns false. Other classes should override this implementation.

Returns
  True if the instance can be printed as a single table of values, false otherwise.

Reimplemented from libdap::Constructor.

Definition at line 254 of file Sequence.cc.

## is_simple_type()

bool libdap::BaseType::is_simple_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a numeric, string or URL type variable.

Returns
  True if the instance is a scalar numeric, String or URL variable, False otherwise. Arrays (even of simple types) return False.

See also
  is_vector_type()

Definition at line 347 of file BaseType.cc.

## is_vector_type()

bool libdap::BaseType::is_vector_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a vector (i.e., array) type variable.

Returns
  True if the instance is an Array, False otherwise.

Definition at line 352 of file BaseType.cc.

## length()

int libdap::Sequence::length | ( |  | ) | const

virtual

Returns the number of elements in a Sequence object. Note that this is not the number of items in a row, but the number of rows in the complete sequence object. To be meaningful, this must be computed after constraint expression (CE) evaluation. The purpose of this function is to facilitate translations between Sequence objects and Array objects, particularly when the Sequence is too large to be transferred from the server to the client in its entirety.

This function, to be useful, must be specialized for the API and data format in use.

Returns
  The base implementation returns -1, indicating that the length is not known. Sub-classes specific to a particular API will have a more complete implementation.

Reimplemented from libdap::BaseType.

Definition at line 360 of file Sequence.cc.

## length_ll()

virtual int64_t libdap::BaseType::length_ll | ( |  | ) | const

inline virtual inherited

Get the number of elements in this variable This version of the function deprecates length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that a Vector/Array holds no values yet (as opposed to zero values). For types not derived from Vector, there is always one element.

Returns
  The number of elements in this variable

Reimplemented in libdap::Str, and libdap::Vector.

Definition at line 216 of file BaseType.h.

## m_duplicate() [1/2]

void libdap::BaseType::m_duplicate | ( | const BaseType & | bt | ) |

protected inherited

Perform a deep copy.

Perform a deep copy. Copies the values of bt into `*this`. Pointers are dereferenced and their values are copied into a newly allocated instance.

Parameters

  bt | The source object.

Definition at line 85 of file BaseType.cc.

## m_duplicate() [2/2]

void libdap::Sequence::m_duplicate | ( | const Sequence & | s | ) |

protected

Definition at line 88 of file Sequence.cc.

## m_exact_match()

BaseType * libdap::Constructor::m_exact_match | ( | const string & | name,
|  | btp_stack * | s = `nullptr`
| ) |  |

protected inherited

Definition at line 237 of file Constructor.cc.

## m_leaf_match()

BaseType * libdap::Constructor::m_leaf_match | ( | const string & | name,
|  | btp_stack * | s = `nullptr`
| ) |  |

protected inherited

Definition at line 214 of file Constructor.cc.

## make_dropped_vars_attr_table()

AttrTable * libdap::Constructor::make_dropped_vars_attr_table | ( | vector< BaseType * > * | dropped_vars | ) |

static inherited

Definition at line 675 of file Constructor.cc.

## name()

string libdap::BaseType::name | ( |  | ) | const

virtual inherited

Returns the name of the class instance.

Definition at line 296 of file BaseType.cc.

## number_of_rows()

int libdap::Sequence::number_of_rows | ( |  | ) | const

virtual

Definition at line 363 of file Sequence.cc.

## operator=()

Sequence & libdap::Sequence::operator= | ( | const Sequence & | rhs | ) |

Definition at line 227 of file Sequence.cc.

## ops()

bool libdap::BaseType::ops | ( | BaseType * | b,
|  | int | op
| ) |  |

virtual inherited

Evaluate relational operators.

This method contains the relational operators used by the constraint expression evaluator in the DDS class. Each class that wants to be able to evaluate relational expressions must overload this function. The implementation in BaseType throws an InternalErr exception. The DAP library classes Byte, ..., Url provide specializations of this method. It is not meaningful for classes such as Array because relational expressions using Array are not supported.

The op argument refers to a table generated by bison from the constraint expression parser. Use statements like the following to correctly interpret its value:

    switch (op) {
        case EQUAL: return i1 == i2;
        case NOT_EQUAL: return i1 != i2;
        case GREATER: return i1 > i2;
        case GREATER_EQL: return i1 >= i2;
        case LESS: return i1 < i2;
        case LESS_EQL: return i1 <= i2;
        case REGEXP: throw Error("Regular expressions are not supported for integer values");
        default: throw Error("Unknown operator");
    }

This function is used by the constraint expression evaluator.

Parameters

  b | Compare the value of this instance with b.
  op | An integer index indicating which relational operator is implied. Choose one from the following: `EQUAL`, `NOT_EQUAL`, `GREATER`, `GREATER_EQL`, `LESS`, `LESS_EQL`, and `REGEXP`.

Returns
  The boolean value of the comparison.

See also
  BaseType::d4_ops(BaseType *, int)

Reimplemented in libdap::D4Opaque, libdap::Byte, libdap::D4Enum, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Int64, libdap::Int8, libdap::Str, libdap::UInt16, libdap::UInt32, and libdap::UInt64.

Definition at line 1101 of file BaseType.cc.

## print_dap4()

void libdap::Constructor::print_dap4 | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

override virtual inherited

Write the DAP4 XML representation for this variable. This method is used to build the DAP4 DMR response object.

Parameters

  xml | An XMLWriter that will do the serialization
  constrained | True if the response should show the variables subject to the current constraint expression.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 601 of file Constructor.cc.

## print_decl() [1/2]

void libdap::Constructor::print_decl | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

override virtual inherited

Print an ASCII representation of the variable structure.

Write the variable's declaration in a C-style syntax. This function is used to create textual representation of the Data Descriptor Structure (DDS). See The DODS User Manual for information about this structure.

A simple array declaration might look like this:

    Float64 lat[lat = 180];

While a more complex declaration (for a Grid, in this case), would look like this:

    Grid {
    ARRAY:
    Int32 sst[time = 404][lat = 180][lon = 360];
    MAPS:
    Float64 time[time = 404];
    Float64 lat[lat = 180];
    Float64 lon[lon = 360];
    } sst;

Parameters

  out | The output stream on which to print the declaration.
  space | Each line of the declaration will begin with the characters in this string. Usually used for leading spaces.
  print_semi | A boolean value indicating whether to print a semicolon at the end of the declaration.
  constraint_info | A boolean value indicating whether constraint information is to be printed with the declaration. If the value of this parameter is TRUE, `print_decl()` prints the value of the variable's `send_p()` flag after the declaration.
  constrained | If this boolean value is TRUE, the variable's declaration is only printed if is the `send_p()` flag is TRUE. If a constraint expression is in place, and this variable is not requested, the `send_p()` flag is FALSE.

See also
  DDS
  DDS::CE

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid, and libdap::D4Group.

Definition at line 506 of file Constructor.cc.

## print_decl() [2/2]

void libdap::Constructor::print_decl | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

override virtual inherited

Print an ASCII representation of the variable structure.

Write the variable's declaration in a C-style syntax. This function is used to create textual representation of the Data Descriptor Structure (DDS). See The DODS User Manual for information about this structure.

A simple array declaration might look like this:

    Float64 lat[lat = 180];

While a more complex declaration (for a Grid, in this case), would look like this:

    Grid {
    ARRAY:
    Int32 sst[time = 404][lat = 180][lon = 360];
    MAPS:
    Float64 time[time = 404];
    Float64 lat[lat = 180];
    Float64 lon[lon = 360];
    } sst;

Parameters

  out | The output stream on which to print the declaration.
  space | Each line of the declaration will begin with the characters in this string. Usually used for leading spaces.
  print_semi | A boolean value indicating whether to print a semicolon at the end of the declaration.
  constraint_info | A boolean value indicating whether constraint information is to be printed with the declaration. If the value of this parameter is TRUE, `print_decl()` prints the value of the variable's `send_p()` flag after the declaration.
  constrained | If this boolean value is TRUE, the variable's declaration is only printed if is the `send_p()` flag is TRUE. If a constraint expression is in place, and this variable is not requested, the `send_p()` flag is FALSE.

See also
  DDS
  DDS::CE

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid, and libdap::D4Group.

Definition at line 512 of file Constructor.cc.

## print_one_row() [1/2]

void libdap::Sequence::print_one_row | ( | FILE * | out,
|  | int | row,
|  | string | space,
|  | bool | print_row_num = `false`
| ) |  |

virtual

Definition at line 1037 of file Sequence.cc.

## print_one_row() [2/2]

void libdap::Sequence::print_one_row | ( | ostream & | out,
|  | int | row,
|  | string | space,
|  | bool | print_row_num = `false`
| ) |  |

virtual

Definition at line 1043 of file Sequence.cc.

## print_val() [1/2]

void libdap::Sequence::print_val | ( | FILE * | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

virtual

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output stream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output stream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Reimplemented from libdap::Constructor.

Definition at line 1112 of file Sequence.cc.

## print_val() [2/2]

void libdap::Sequence::print_val | ( | ostream & | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

virtual

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output ostream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Reimplemented from libdap::Constructor.

Definition at line 1116 of file Sequence.cc.

## print_val_by_rows() [1/2]

void libdap::Sequence::print_val_by_rows | ( | FILE * | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`,
|  | bool | print_row_numbers = `true`
| ) |  |

virtual

Definition at line 1084 of file Sequence.cc.

## print_val_by_rows() [2/2]

void libdap::Sequence::print_val_by_rows | ( | ostream & | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`,
|  | bool | print_row_numbers = `true`
| ) |  |

virtual

Definition at line 1090 of file Sequence.cc.

## print_xml() [1/2]

void libdap::Constructor::print_xml | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

override virtual inherited

Deprecated:

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 559 of file Constructor.cc.

## print_xml() [2/2]

void libdap::Constructor::print_xml | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

override virtual inherited

Deprecated:

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 568 of file Constructor.cc.

## print_xml_writer()

void libdap::Constructor::print_xml_writer | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

override virtual inherited

Write the XML representation of this variable. This method is used to build the DDX XML response.

Parameters

  out | Destination output stream
  space | Use this to indent child declarations. Default is "".
  constrained | If true, only print this if it's part part of the current projection. Default is False.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 574 of file Constructor.cc.

## ptr_duplicate()

BaseType * libdap::Sequence::ptr_duplicate | ( |  | ) |

virtual

Clone this instance. Allocate a new instance and copy `*this` into it. This method must perform a deep copy.

    @note This method should \e not copy data values, but must copy all
    other fields in the object.

Returns
  A newly allocated copy of `this`.

Implements libdap::BaseType.

Definition at line 167 of file Sequence.cc.

## read()

bool libdap::Constructor::read | ( |  | ) |

override virtual inherited

Read the elements of Constructor marked for transmission.

Iterate over the top level members of the Constructor and read all of them that have the 'send_p' property set to true. Assume the read() methods correctly set the 'read_p' property. Once done, set 'read_p' for the Constructor itself (but not for the members, that is left up to their individual read() methods).

Returns
  returns false; the return value is a relic.

Reimplemented from libdap::BaseType.

Definition at line 386 of file Constructor.cc.

## read_p()

bool libdap::BaseType::read_p | ( |  | ) |

virtual inherited

Has this variable been read?

Returns true if the value(s) for this variable have been read from the data source, otherwise returns false. This method is used to determine when values need to be read using the read() method. When read_p() returns true, this library assumes that buf2val() (and other methods such as get_vec()) can be used to access the value(s) of a variable.

Returns
  True if the variable's value(s) have been read, false otherwise.

Definition at line 410 of file BaseType.cc.

## read_row()

bool libdap::Sequence::read_row | ( | int | row,
|  | DDS & | dds,
|  | ConstraintEvaluator & | eval,
|  | bool | ce_eval = `true`
| ) |  |

virtual

Read row number row of the Sequence. The values of the row are obtained by calling the read() method of the sequence. The current row just read is stored in the Sequence instance along with its row number. If a selection expression has been supplied, rows are counted only if they satisfy that expression.

Note that we can only advance in a Sequence. It is not possible to back up and read a row numbered lower than the current row. If you need that you will need to replace the serialize() method with one of your own.

Used on the server side.

Note
  The first row is row number zero. A Sequence with 100 rows will have row numbers 0 to 99.

Todo:
  This code ignores the main reason for nesting the sequences, that if the outer Sequence's current instance fails the CE, there's no need to look at the values of the inner Sequence. But in the code that calls this method (serialize() and intern_data()) the CE is not evaluated until the inner-most Sequence (i.e., the leaf Sequence) is read. That means that each instance of the inner Sequence is read and the CE evaluated for each of those reads. To fix this, and the overall problem of complexity here, we need to re-think Sequences and how they behave. 11/13/2007 jhrg

Returns
  A boolean value, with TRUE indicating that read_row should be called again because there's more data to be read. FALSE indicates the end of the Sequence.

Parameters

  row | The row number to read.
  dds | A reference to the DDS for this dataset.
  eval | Use this as the constraint expression evaluator.
  ce_eval | If True, evaluate any CE, otherwise do not.

Definition at line 436 of file Sequence.cc.

## reset_row_number() [1/2]

void libdap::Sequence::reset_row_number | ( |  | ) |

Rest the row number counter.

When reading a nested sequence, use this method to reset the internal row number counter. This is necessary so that the second, ... instances of the inner/nested sequence will start off reading row zero.

Definition at line 368 of file Sequence.cc.

## reset_row_number() [2/2]

void libdap::Sequence::reset_row_number | ( | bool | recur | ) |

A recursive version of reset_row_number()

Parameters

  recur | If true, reset the row number of child sequences as well

Definition at line 375 of file Sequence.cc.

## row_value()

BaseTypeRow * libdap::Sequence::row_value | ( | size_t | row | ) |

virtual

Get a whole row from the sequence.

Parameters

  row | Get row number row from the sequence.

Returns
  A BaseTypeRow object (vector<BaseType *>). Null if there's no such row number as row.

Definition at line 283 of file Sequence.cc.

## send_p()

bool libdap::BaseType::send_p | ( |  | ) |

virtual inherited

Should this variable be sent?

Returns the state of the `send_p` property. If true, this variable should be sent to the client, if false, it should not. If no constraint expression (CE) has been evaluated, this property is true for all variables in a data source (i.e., for all the variables listed in a DDS). If a CE has been evaluated, this property is true only for those variables listed in the projection part of the CE.

Returns
  True if the variable should be sent to the client, false otherwise.

Definition at line 478 of file BaseType.cc.

## serialize() [1/2]

bool libdap::Sequence::serialize | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds,
|  | Marshaller & | m,
|  | bool | ce_eval = `true`
| ) |  |

virtual

Serialize a Sequence.

Leaf Sequences must be marked as such (see DDS::tag_nested_sequence()), as must the top most Sequence.

How the code works. Methods called for various functions are named in brackets:

1. Sending a one-level sequence:

       Dataset {
           Sequence {
               Int x;
               Int y;
           } flat;
       } case_1;

   Serialize case_1 by reading successive rows and sending all of those that satisfy the CE. Before each row, send a start of instance (SOI) marker. Once all rows have been sent, send an End of Sequence (EOS) marker.[serialize_leaf].

2. Sending a nested sequence:

       Dataset {
           Sequence {
               Int t;
               Sequence {
                   Int z;
               } inner;
           } outer;
       } case_2;

   Serialize case_2 by reading the first row of outer and storing the values. Do not evaluate the CE [serialize_parent_part_one]. Call serialize() for inner and read each row for it, evaluating the CE for each row that is read. After the first row of inner is read and satisfies the CE, write out the SOI marker and values for outer [serialize_parent_part_two], then write the SOI and values for the first row of inner. Continue to read and send rows of inner until the last row has been read. Send EOS for inner [serialize_leaf]. Now read the next row of outer and repeat. Once outer is completely read, send its EOS marker.

Notes:

1. For a nested Sequence, the child sequence must follow all other types in the parent sequence (like the example). There may be only one nested Sequence per level.

2. CE evaluation happens only in a leaf sequence.

3. When no data satisfies a CE, the empty Sequence is signaled by a single EOS marker, regardless of the level of nesting of Sequences. That is, the EOS marker is sent for only the outer Sequence in the case of a completely empty response.

Reimplemented from libdap::Constructor.

Definition at line 545 of file Sequence.cc.

## serialize() [2/2]

void libdap::Constructor::serialize | ( | D4StreamMarshaller & | m,
|  | DMR & | dmr,
|  | bool | filter = `false`
| ) |  |

override virtual inherited

Serialize a Constructor.

Todo:
  See notebook for 8/21/14

Parameters

  m |
  dmr | Unused
  eval | Unused
  filter | Unused

Exceptions

  Error | is thrown if the value needs to be read and that operation fails.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group, and libdap::D4Sequence.

Definition at line 479 of file Constructor.cc.

## serialize_leaf()

bool libdap::Sequence::serialize_leaf | ( | DDS & | dds,
|  | ConstraintEvaluator & | eval,
|  | Marshaller & | m,
|  | bool | ce_eval
| ) |  |

protected virtual

Definition at line 652 of file Sequence.cc.

## serialize_parent_part_one()

bool libdap::Sequence::serialize_parent_part_one | ( | DDS & | dds,
|  | ConstraintEvaluator & | eval,
|  | Marshaller & | m
| ) |  |

protected virtual

Definition at line 561 of file Sequence.cc.

## serialize_parent_part_two()

void libdap::Sequence::serialize_parent_part_two | ( | DDS & | dds,
|  | ConstraintEvaluator & | eval,
|  | Marshaller & | m
| ) |  |

protected virtual

Definition at line 624 of file Sequence.cc.

## set_attr_table()

void libdap::BaseType::set_attr_table | ( | const AttrTable & | at | ) |

virtual inherited

Set this variable's attribute table.

Parameters

  at | Source of the attributes.

Definition at line 502 of file BaseType.cc.

## set_attributes()

void libdap::BaseType::set_attributes | ( | D4Attributes * | attrs | ) |

virtual inherited

Definition at line 513 of file BaseType.cc.

## set_attributes_nocopy()

void libdap::BaseType::set_attributes_nocopy | ( | D4Attributes * | attrs | ) |

virtual inherited

Definition at line 515 of file BaseType.cc.

## set_in_selection()

void libdap::Constructor::set_in_selection | ( | bool | state | ) |

override virtual inherited

Set the in_selection property.

Set the in_selection property for this variable and all of its children.

Parameters

  state | Set the property value to state.

Reimplemented from libdap::BaseType.

Definition at line 656 of file Constructor.cc.

## set_is_dap4()

virtual void libdap::BaseType::set_is_dap4 | ( | const bool | v | ) |

inline virtual inherited

Definition at line 182 of file BaseType.h.

## set_leaf_p()

void libdap::Sequence::set_leaf_p | ( | bool | state | ) |

virtual

Definition at line 1120 of file Sequence.cc.

## set_leaf_sequence()

void libdap::Sequence::set_leaf_sequence | ( | int | lvl = `1` | ) |

virtual

Mark the Sequence which holds the leaf elements.

In a nested Sequence, the Sequence which holds the leaf elements is special because it during the serialization of this Sequence's data that constraint Expressions must be evaluated. If CEs are evaluated at the upper levels, then valid data may not be sent because it was effectively hidden from the serialization and evaluation code (see the documentation for the serialize_leaf() method).

The notion of the leaf Sequence needs to be modified to mean the lowest level of a Sequence where data are to be sent. Suppose there's a two level Sequence, but that only fields from the top level are to be sent. Then that top level is also the leaf Sequence and should be marked as such. If the lower level is marked as a leaf Sequence, then no values will ever be sent since the send_p property will always be false for each field and it's the call to serialize_leaf() that actually triggers transmission of values (because it's not until the code makes it into serialize_leaf() that it knows there are values to be sent.

Note
  This method must not be called before the CE is parsed.

Parameters

  lvl | The current level of the Sequence. a lvl of 1 indicates the topmost Sequence. The default value is 1.

See also
  Sequence::serialize_leaf()

Definition at line 1148 of file Sequence.cc.

## set_length()

virtual void libdap::BaseType::set_length | ( | int64_t |  | ) |

inline virtual inherited

Set the number of elements for this variable. use -1 to indicate nothing set.

See also
  Vector

Parameters

  l | The number of elements

Deprecated:
  Use set_length_ll() instead

Reimplemented in libdap::D4Sequence, and libdap::Vector.

Definition at line 224 of file BaseType.h.

## set_length_ll()

virtual void libdap::BaseType::set_length_ll | ( | int64_t |  | ) |

inline virtual inherited

Set the number of elements in this variable This version of the function deprecates set_length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values.

Parameters

  l | The number of elements in the variable

Reimplemented in libdap::Vector.

Definition at line 232 of file BaseType.h.

## set_name()

void libdap::BaseType::set_name | ( | const string & | n | ) |

virtual inherited

Sets the name of the class instance.

Reimplemented in libdap::Vector.

Definition at line 314 of file BaseType.cc.

## set_parent()

void libdap::BaseType::set_parent | ( | BaseType * | parent | ) |

virtual inherited

Set the `parent` property for this variable.

Note
  Added ability to set parent to null. 10/19/12 jhrg

Parameters

  parent | Pointer to the Constructor of Vector parent variable or null if the variable has no parent (if it is at the top-level of a DAP2/3 DDS).

Exceptions

  InternalErr | thrown if called with anything other than a Constructor, Vector or Null.

Definition at line 622 of file BaseType.cc.

## set_read_p()

void libdap::Constructor::set_read_p | ( | bool | state | ) |

override virtual inherited

Set the 'read_p' property for the Constructor and its members.

This method sets read_p for all of the Constructor. The read() method is much more selective and only sets read_p for the Constructor itself, leaving the value of the property of the members up to their read() methods. Calling this with false will clear the property of all the member variables.

Parameters

  state | Set the read_p property to this state.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 140 of file Constructor.cc.

## set_row_number_constraint()

void libdap::Sequence::set_row_number_constraint | ( | int | start,
|  | int | stop,
|  | int | stride = `1`
| ) |  |

virtual

Set the start, stop and stride for a row-number type constraint. This should be used only when the sequence is constrained using the bracket notation (which supplies start, stride and stop information). If omitted, the stride defaults to 1.

Parameters

  start | The starting row number. The first row is row zero.
  stop | The ending row number. The 20th row is row 19.
  stride | The stride. A stride of two skips every other row.

Definition at line 1028 of file Sequence.cc.

## set_send_p()

void libdap::Constructor::set_send_p | ( | bool | state | ) |

override virtual inherited

Sets the value of the `send_p` flag. This function is meant to be called from within the constraint evaluator of other code which determines that this variable should be returned to the client. Data are ready to be sent when both the `d_is_send` and `d_is_read` flags are set to TRUE.

Parameters

  state | The logical state to set the `send_p` flag.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 121 of file Constructor.cc.

## set_synthesized_p()

void libdap::BaseType::set_synthesized_p | ( | bool | state | ) |

virtual inherited

Set the synthesized flag. Before setting this flag be sure to set the `read_p()` state. Once this flag is set you cannot alter the state of the `read_p` flag!

See also
  synthesized_p()

Definition at line 397 of file BaseType.cc.

## set_type()

void libdap::BaseType::set_type | ( | const Type & | t | ) |

virtual inherited

Sets the type of the class instance.

Definition at line 332 of file BaseType.cc.

## set_unsent_data()

void libdap::Sequence::set_unsent_data | ( | bool | usd | ) |

inline

Set the unsent data property.

Definition at line 272 of file Sequence.h.

## set_value()

void libdap::Sequence::set_value | ( | SequenceValues & | values | ) |

virtual

Set value of this Sequence. This does not perform a deep copy, so data should be allocated on the heap and freed only when the Sequence dtor is called.

See also
  SequenceValues
  BaseTypeRow

Parameters

  values | Set the value of this Sequence.

Definition at line 295 of file Sequence.cc.

## set_var_index()

void libdap::Constructor::set_var_index | ( | BaseType * | bt,
|  | int | i
| ) |  |

inherited

Set the ith element of d_vars to a variable object.

Note
  This method only sets the ith element to a BaseType object. The user should be responsible to release or allocate the resource properly. Use this method cautionally.

Parameters

  bt | A pointer to the variable that is assigned to the ith element.
  i | The index of the variable to be set.

Definition at line 301 of file Constructor.cc.

## synthesized_p()

bool libdap::BaseType::synthesized_p | ( |  | ) |

virtual inherited

Returns true if the variable is a synthesized variable. A synthesized variable is one that is added to the dataset by the server (usually with a ‘projection function’.

Definition at line 390 of file BaseType.cc.

## toString()

string libdap::Sequence::toString | ( |  | ) |

virtual

Write out the object's internal fields in a string. To be used for debugging when regular inspection w/ddd or gdb isn't enough.

Returns
  A string which shows the object's internal stuff.

Reimplemented from libdap::BaseType.

Definition at line 240 of file Sequence.cc.

## transfer_attributes()

void libdap::Constructor::transfer_attributes | ( | AttrTable * | at_container | ) |

override virtual inherited

Transfer attributes from a DAS object into this variable. Because of the rough history of the DAS object and the way that various server code built the DAS, this is necessarily a heuristic process. The intent is that this method will be overridden by handlers that need to look for certain patterns in the DAS (e.g., hdf4's odd variable_dim_n; where n = 0, 1, 2, ...) attribute containers.

There should be a one-to-one mapping between variables and attribute containers. However, in some cases one variable has attributes spread across several top level containers and in some cases one container is used by several variables

Note
  This method is technically unnecessary because a server (or client) can easily add attributes directly using the DDS::get_attr_table or BaseType::get_attr_table methods and then poke values in using any of the methods AttrTable provides. This method exists to ease the transition to DDS objects which contain attribute information for the existing servers (Since they all make DAS objects separately from the DDS). They could be modified to use the same AttrTable methods but operate on the AttrTable instances in a DDS/BaseType instead of those in a DAS.

Parameters

  at_container | Transfer attributes from this container.

Returns
  void

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 664 of file Constructor.cc.

## transform_to_dap2()

std::vector< BaseType * > * libdap::BaseType::transform_to_dap2 | ( | AttrTable * | parent_attr_table | ) |

virtual inherited

DAP4 to DAP2 transform.

For the current BaseType, return a DAP2 'copy' of the variable.

Note
  For most DAP4 types, in this implementation of DAP2 the corresponding DAP4 type is the same. These types have a different representations in DAP2 and DAP4: Sequences (which are D4Sequences in the DAP4 implementation),
  - Grids (which are semantically subsumed by coverages in DAP4)
  - Arrays (which use shared dimensions in DAP4)

Additionally DAP4 adds the following types:

- UInt8, Int8, and Char which map to Byte in DAP2.
- Int64, Unit64 which have no natural representation in DAP2.
- Opaque Possible Byte stuff[] plus metadata?
- Enum's can be represented as Int32.
- Groups, with the exception of the root group "disappear" into the names of their member variables. Specifically the Group name is add as a prefix followed by a "/" separator to the names of all of the Group's member groups variables.

Parameters

  The | AttrTable pointer parent_attr_table is used by Groups, which disappear from the DAP2 representation. Their children are returned in the the BAseType vector their attributes are added to parent_attr_table;

Returns
  A pointer to a vector of BaseType pointers (right?). In most cases this vector will contain a single pointer but DAP4 types 'disappear' such as Group will return all of their member variables in the vector. DAP4 types with no representation in DAP2 (ex: UInt64) the will return a NULL pointer and so this must be tested!

Reimplemented in libdap::Structure, libdap::Array, libdap::Byte, libdap::D4Enum, libdap::D4Group, libdap::D4Opaque, libdap::Int64, libdap::Int8, and libdap::UInt64.

Definition at line 240 of file BaseType.cc.

## transform_to_dap4()

void libdap::Sequence::transform_to_dap4 | ( | D4Group * | root,
|  | Constructor * | container
| ) |  |

virtual

Build a D4Sequence from a DAP2 Sequence.

Because DAP4 uses a different type for sequences, this code must be subclassed by anything other than trivial test code or client side-only uses of the library.

Note
  This version of transformto_dap4() builds a new type of object, so it must be subclassed.

Parameters

  root | Use this as the environment for D4Dimensions
  container | Load the result into this container

Returns
  The new D4Sequence

Reimplemented from libdap::Constructor.

Definition at line 183 of file Sequence.cc.

## type()

Type libdap::BaseType::type | ( |  | ) | const

virtual inherited

Returns the type of the class instance.

Definition at line 329 of file BaseType.cc.

## type_name()

string libdap::BaseType::type_name | ( |  | ) | const

virtual inherited

Returns the type of the class instance as a string.

Definition at line 335 of file BaseType.cc.

## val2buf()

unsigned int libdap::Constructor::val2buf | ( | void * | val,
|  | bool | reuse
| ) |  |

inline override virtual inherited

Loads class data.

Store the value pointed to by val in the object's internal buffer. This function does not perform any checks, so users must be sure that the thing pointed to can actually be stored in the object's buffer.

Only simple objects (Int, Float, Byte, and so on) and arrays of these simple objects may be stored using this function. To put data into more complex constructor types, use the functions provided by that class.

Deprecated:
  Use set_value() in the leaf classes.

Parameters

  val | A pointer to the data to be inserted into the class data buffer.
  reuse | A boolean value, indicating whether the class internal data storage can be reused or not. If this argument is TRUE, the class buffer is assumed to be large enough to hold the incoming data, and it is not reallocated. If FALSE, new storage is allocated. If the internal buffer has not been allocated at all, this argument has no effect. This is currently used only in the Vector class.

Returns
  The size (in bytes) of the information copied from val.

See also
  Grid
  Vector::val2buf

Implements libdap::BaseType.

Definition at line 134 of file Constructor.h.

## value()

SequenceValues libdap::Sequence::value | ( |  | ) |

virtual

Get the value for this sequence.

Returns
  The SequenceValues object for this Sequence.

Definition at line 299 of file Sequence.cc.

## value_ref()

SequenceValues & libdap::Sequence::value_ref | ( |  | ) |

virtual

Get the value for this sequence.

Returns
  The SequenceValues object for this Sequence.

Definition at line 303 of file Sequence.cc.

## var() [1/2]

BaseType * libdap::Constructor::var | ( | const string & | n,
|  | btp_stack & | s
| ) |  |

override virtual inherited

btp_stack no longer needed; use back pointers (BaseType::get_parent())

Deprecated:

Deprecated:
  See comment in BaseType

Reimplemented from libdap::BaseType.

Definition at line 201 of file Constructor.cc.

## var() [2/2]

BaseType * libdap::Constructor::var | ( | const string & | name,
|  | bool | exact_match = `true`,
|  | btp_stack * | s = `nullptr`
| ) |  |

override virtual inherited

btp_stack no longer needed; use back pointers (BaseType::get_parent())

Reimplemented from libdap::BaseType.

Definition at line 191 of file Constructor.cc.

## var_begin()

Constructor::Vars_iter libdap::Constructor::var_begin | ( |  | ) |

inherited

Returns an iterator referencing the first structure element.

Definition at line 269 of file Constructor.cc.

## var_end()

Constructor::Vars_iter libdap::Constructor::var_end | ( |  | ) |

inherited

Returns an iterator referencing the end of the list of structure elements. Does not reference the last structure element.

Definition at line 273 of file Constructor.cc.

## var_rbegin()

Constructor::Vars_riter libdap::Constructor::var_rbegin | ( |  | ) |

inherited

Return a reverse iterator that references the last element.

Definition at line 276 of file Constructor.cc.

## var_rend()

Constructor::Vars_riter libdap::Constructor::var_rend | ( |  | ) |

inherited

Return a reverse iterator that references a point 'before' the first element.

Definition at line 280 of file Constructor.cc.

## var_value() [1/2]

BaseType * libdap::Sequence::var_value | ( | size_t | row,
|  | const string & | name
| ) |  |

virtual

Get the BaseType pointer to the named variable of a given row.

Parameters

  row | Read from row in the sequence.
  name | Return name from row.

Returns
  A BaseType which holds the variable and its value.

See also
  number_of_rows

Definition at line 310 of file Sequence.cc.

## var_value() [2/2]

BaseType * libdap::Sequence::var_value | ( | size_t | row,
|  | size_t | i
| ) |  |

virtual

Get the BaseType pointer to the $i^{th}$ variable of row.

Parameters

  row | Read from row in the sequence.
  i | Return the $i^{th}$ variable from row.

Returns
  A BaseType which holds the variable and its value.

See also
  number_of_rows

Definition at line 331 of file Sequence.cc.

## variables()

const vector< BaseType * > & libdap::Constructor::variables | ( |  | ) | const

inline inherited

Get a const reference to the vector of BaseType pointers.

Note
  Use this in range-based for loops to iterate over the variables.

Returns
  A const reference to the vector of BaseType pointers.

Definition at line 110 of file Constructor.h.

## width()

unsigned int libdap::Constructor::width | ( | bool | constrained = `false` | ) | const

override virtual inherited

This version of width simply returns the same thing as width() for simple types and Arrays. For Structure it returns the total size if constrained is false, or the size of the elements in the current projection if true.

Parameters

  constrained | If true, return the size after applying a constraint.

Returns
  The number of bytes used by the variable.

Deprecated:
  Use width_ll()

Reimplemented from libdap::BaseType.

Definition at line 156 of file Constructor.cc.

## width_ll()

int64_t libdap::Constructor::width_ll | ( | bool | constrained = `false` | ) | const

override virtual inherited

Get the width of the Constructor's fields.

Parameters

  constrained | If true, return the constrained size

Returns
  The number of bytes needed to store the values of this instance

Reimplemented from libdap::BaseType.

Definition at line 176 of file Constructor.cc.

## Friends And Related Symbol Documentation

## SequenceTest

friend class SequenceTest

friend

Definition at line 199 of file Sequence.h.

## Member Data Documentation

## d_vars

std::vector<BaseType *> libdap::Constructor::d_vars

protected inherited

Definition at line 47 of file Constructor.h.

The documentation for this class was generated from the following files:

- Sequence.h
- Sequence.cc